#include <stdio.h>   /* Standard input/output definitions */
#include <stdbool.h> /* Standard boolean definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */

#define Epsilon (0.00005)

char* getChunkFile(char* buffer, int chunk) {
	sprintf(buffer, "./parse/out.%i", chunk);
	return buffer;
}

unsigned int getLines(char* fileName) {
	FILE* fp = fopen(fileName, "r");
	unsigned int size = 0;
	char buffer[80];
	while(fgets(buffer, 80, fp)) size++;
	fclose(fp);
	return size;
}

unsigned int maximum(unsigned int argc, unsigned int argv[]) {
	unsigned int i;
	unsigned int max = argv[0];
	for(i = 1; i < argc; i++)
		if(argv[i] > max)
			max = argv[i];
	return max;
}

void echoArr(unsigned int argc, unsigned int argv[]) {
	unsigned int i;
	for(i = 0; i < argc; i++)
		printf("%5u", argv[i]);
}

void diffArr(unsigned int argc, unsigned int argv[]) {
	unsigned int i;
	for(i = 1; i < argc; i++) {
		long x = ((long) argv[i] - (long) argv[0]);
		if(x >= 5)		argv[i] = 1;
		else if(x <= -5)	argv[i] = 2;
		else			argv[i] = 0;
	}
}

int main(int argc, char* argv[]) {
	if(argc < 2)
		return 1;

	char buffer[80];

	unsigned int chunk = atoi(argv[1]) + 1;
	unsigned int lengths[chunk];

	unsigned int i;
	for(i = 0; i < chunk; i++) {
		getChunkFile(buffer, i);
		lengths[i] = getLines(buffer);
	}

	unsigned int max = maximum(chunk, lengths);

	unsigned int files[max][chunk + 1];

	FILE* fp = fopen("./parse/median.out", "r");
	unsigned int j = 0;
	while(fgets(buffer, 80, fp)){
		files[j++][0] = atoi(buffer);
	}
	fclose(fp);

	for(i = 0; i < chunk; i++) {
		getChunkFile(buffer, i);
		fp = fopen(buffer, "r");
		j = 0;
		while(fgets(buffer, 80, fp)){
			files[j++][i + 1] = atoi(buffer);
		}
		fclose(fp);
	}

	for(i = 0; i < max; i++) {
		unsigned int* filesP = files[i];
		diffArr(chunk + 1, filesP);
	}

	fp = fopen("./parse/diff.out", "w");
	for(i = 0; i < chunk; i++) {
		unsigned int j;
		for(j = 0; j < max; j++)
			fprintf(fp, "%u", files[j][i + 1]);
		fprintf(fp, "\n");
	}
	fclose(fp);
}
