#include <stdio.h>   /* Standard input/output definitions */
#include <stdbool.h> /* Standard boolean definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */

char* getChunkFile(char* buffer, int chunk) {
	sprintf(buffer, "./parse/out.%i", chunk);
	return buffer;
}

unsigned int getLines(char* fileName) {
	FILE* fp = fopen(fileName, "r");
	unsigned int size = 0;
	char buffer[80];
	while(fgets(buffer, 80, fp)) size++;
	fclose(fp);
	return size;
}

unsigned int maximum(unsigned int argc, unsigned int argv[]) {
	unsigned int i;
	unsigned int max = argv[0];
	for(i = 1; i < argc; i++)
		if(argv[i] > max)
			max = argv[i];
	return max;
}

void echoArr(unsigned int argc, unsigned int argv[]) {
	unsigned int i;
	for(i = 0; i < argc; i++)
		printf("%5u", argv[i]);
}

void bubbleSort(unsigned int argc, unsigned int argv[]) {
	bool done;
	do {
		done = false;
		unsigned int i;
		for(i = 0; i < argc - 1; i++) {
			if(argv[i] > argv[i + 1]) {
				unsigned int th = argv[i];
				argv[i] = argv[i + 1];
				argv[i + 1] = th;
				done = true;
			}
		}
		argc--;
	} while((done) && (argc > 1));
}

int main(int argc, char* argv[]) {
	if(argc < 2)
		return 1;

	char buffer[80];

	unsigned int chunk = atoi(argv[1]) + 1;
	unsigned int lengths[chunk];

	unsigned int i;
	for(i = 0; i < chunk; i++) {
		getChunkFile(buffer, i);
		lengths[i] = getLines(buffer);
	}

	unsigned int max = maximum(chunk, lengths);

	unsigned int files[max][chunk];
	for(i = 0; i < chunk; i++) {
		getChunkFile(buffer, i);
		unsigned int j = 0;
		FILE* fp = fopen(buffer, "r");
		while(fgets(buffer, 80, fp)){
			files[j++][i] = atoi(buffer);
		}
		fclose(fp);
	}

	unsigned int medianI = (chunk / 2);
	unsigned int median[max];

	for(i = 0; i < max; i++) {
		unsigned int* filesP = files[i];
		bubbleSort(chunk, filesP);
		median[i] = filesP[medianI];
	}


	FILE* fp = fopen("./parse/median.out", "w");
	for(i = 0; i < max; i++)
		fprintf(fp, "%u\n", median[i]);
	fclose(fp);
}
